'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var t = _ref.types;

  return {
    visitor: {
      ImportDeclaration: function ImportDeclaration(path, state) {
        var node = path.node;
        var importTarget = node.source.value;

        if (!/!text$/.test(importTarget)) {
          return;
        }

        var specifier = node.specifiers[0];

        t.assertImportDefaultSpecifier(specifier);

        var varName = specifier.local;
        var fsModule = t.callExpression(t.identifier('require'), [t.stringLiteral('fs')]);
        var readFileSync = t.memberExpression(fsModule, t.identifier('readFileSync'));

        path.replaceWith(t.variableDeclaration('var', [t.variableDeclarator(varName, t.callExpression(readFileSync, [t.stringLiteral(resolveImportPath(importTarget.split('!')[0], state.opts.basePath)), t.stringLiteral(state.opts.encoding || 'utf8')]))]));
      }
    }
  };

  function resolveImportPath(target, base) {
    // target path begins with '/', './', or '../'
    if (/^\/|^\.\/|^\.\.\//.test(target)) {
      return target;
    }

    if (typeof base !== 'string') {
      throw new Error('Cannot import \'' + target + '!text\' without specifying a basePath option.');
    }

    return _path2.default.join(base, target);
  }
};

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }